SystemOrganization addCategory: #Tp1_Abejas!

Object subclass: #Abeja
	instanceVariableNames: 'aguijon colmena nectar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:30'!
aguijon
	^ aguijon! !

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:30'!
aguijon: anObject
	aguijon := anObject! !

!Abeja methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 20:24'!
aumentarNectar: unaCantidad
self nectar: (self nectar + unaCantidad).! !

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:00'!
colmena
	^ colmena! !

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:00'!
colmena: anObject
	colmena := anObject! !

!Abeja methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 20:24'!
comer: unaCantidad deNectarDe: unaColmena
^(unaCantidad <= unaColmena nectar)
	ifTrue: [self aumentarNectar: unaCantidad.
	unaColmena disminuirNectarEn: unaCantidad.]
	ifFalse: [ Error signal: 'No se puede dar de comer a mas abejas ya que no alcanza la cantidad de nectar en la colmena' ].
! !

!Abeja methodsFor: 'as yet unclassified' stamp: 'Facundo 5/22/2013 20:09'!
morir
(self colmena) abejas remove: self.! !

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:55'!
nectar
	^ nectar! !

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:55'!
nectar: anObject
	nectar := anObject! !

!Abeja methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 17:22'!
puedePicar
^self aguijon.
! !

Abeja subclass: #Guardiana
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:58'!
buscarIntrusasEn: unaPiquera
^ unaPiquera abejas select: [:unaAbeja | (unaAbeja colmena == self colmena) not].
"unaPiquera abejas detect: [:unaAbeja | (unaAbeja colmena == self colmena) not]."
! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 13:52'!
damePiqueraDe: unaColmena
^ unaColmena piquera.! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 21:13'!
initialize
self aguijon: true.! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 13:20'!
picar: unaAbeja
self colmena piquera sacarAbeja: unaAbeja.
self colmena piquera sacarAbeja: self.
unaAbeja morir.
self morir.
! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 20:11'!
picarSiHayIntrusa: unasAbejas
(unasAbejas size> 0)
	ifTrue: [self picar: (unasAbejas asOrderedCollection) first].! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 13:47'!
piqueraQueVigila
^ self damePiqueraDe: self colmena.! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 13:45'!
realizarTarea
self picarSiHayIntrusa: (self buscarIntrusasEn: self piqueraQueVigila).

"piquera abejas select: [ :unaAbeja | (unaAbeja colmena == self colmena) not ]"! !

Abeja subclass: #Pecoreadora
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 5/22/2013 21:37'!
cambiarRolAGuardiana
|nuevaGuardiana|
nuevaGuardiana := Guardiana new.
nuevaGuardiana colmena: self colmena.
nuevaGuardiana aguijon: self aguijon.
nuevaGuardiana nectar: self nectar.
^nuevaGuardiana.! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 5/22/2013 21:51'!
elegirFlor
^ ((self colmena floresCercanas) asOrderedCollection) first! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 5/22/2013 21:13'!
initialize
self aguijon: true.! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:22'!
nectarRecolectadoDe: unaFlor
^ unaFlor quitarNectar.

! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:40'!
realizarTarea
self recolectarDe: self elegirFlor yDepositarEn: self colmena.! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:22'!
recolectarDe: unaFlor yDepositarEn: unaColmena
unaColmena aumentarNectarEn: (self nectarRecolectadoDe: unaFlor).
unaFlor disminuirNectarEn: (self nectarRecolectadoDe: unaFlor).! !

Abeja subclass: #Reina
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Reina methodsFor: 'as yet unclassified' stamp: 'Facundo 5/24/2013 11:33'!
initialize
self aguijon: false.! !

!Reina methodsFor: 'as yet unclassified' stamp: 'Facundo 5/24/2013 11:43'!
realizarTarea 
|cantidadParaReproducir cantidadParaReproducirZanganos cantidadParaReproducirObreras|

cantidadParaReproducir := self colmena nectar * 0.3.
cantidadParaReproducirZanganos := cantidadParaReproducir * 0.2.
cantidadParaReproducirObreras := cantidadParaReproducir * 0.8.

cantidadParaReproducirZanganos timesRepeat: [ self colmena abejas add: Zangano new ].
(cantidadParaReproducirObreras // 2) timesRepeat: [ self colmena abejas add: Pecoreadora new ].
(cantidadParaReproducirObreras // 2) timesRepeat: [ self colmena abejas add: Guardiana new ].! !

Abeja subclass: #Zangano
	instanceVariableNames: 'corrienteDeAire'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Zangano methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:45'!
corrienteDeAire
	^ corrienteDeAire! !

!Zangano methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:45'!
corrienteDeAire: anObject
	corrienteDeAire := anObject! !

!Zangano methodsFor: 'as yet unclassified' stamp: 'Facundo 5/24/2013 11:34'!
initialize 
self aguijon: false.! !

!Zangano methodsFor: 'as yet unclassified' stamp: 'Facundo 5/22/2013 22:03'!
realizarTarea
self colmena reducirTemperaturaEn: self corrienteDeAire.! !

Object subclass: #Apiario
	instanceVariableNames: 'colmenas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 21:08'!
colmenaMasFuerte
^ (self colmenas asSortedCollection: [:unaColmena :otraColmena | unaColmena cuantasPican >= otraColmena cuantasPican]) first.! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
colmenas
	^ colmenas! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
colmenas: anObject
	colmenas := anObject! !

Object subclass: #Colmena
	instanceVariableNames: 'abejas floresCercanas nectar piquera temperatura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
abejas
	^ abejas! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
abejas: anObject
	abejas := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 20:17'!
alcanzaNectar: unaCantidad
^(unaCantidad <= self nectar)


	
! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:03'!
aumentarNectarEn: unaCantidad.
self nectar:  (self nectar + unaCantidad).! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 20:36'!
comanNectar: unaCantidad
^[self abejas do: [:unaAbeja | unaAbeja comer: unaCantidad deNectarDe: self]] on: Error do: [:e | e messageText].! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 17:44'!
cuantasPican
^self abejas count: [:unaAbeja | unaAbeja puedePicar]! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:57'!
disminuirNectarEn: unaCantidad.
self nectar:  (self nectar - unaCantidad).! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:55'!
floresCercanas
	^ floresCercanas! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:55'!
floresCercanas: anObject
	floresCercanas := anObject! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:02'!
nectar
	^ nectar! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:02'!
nectar: anObject
	nectar := anObject! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:38'!
piquera
	^ piquera! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:38'!
piquera: anObject
	piquera := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:49'!
realicenTarea
self abejas do: [ :unaAbeja | unaAbeja realizarTarea ].! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/23/2013 00:45'!
reducirTemperaturaEn: unaCantidad
self temperatura: (self temperatura - unaCantidad).
! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:43'!
temperatura
	^ temperatura! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:43'!
temperatura: anObject
	temperatura := anObject! !

Object subclass: #Flor
	instanceVariableNames: 'kmHastaColmena nectar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:23'!
disminuirNectarEn: unaCantidad
self nectar: (self nectar - unaCantidad).! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:14'!
nectar
	^ nectar! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:14'!
nectar: anObject
	nectar := anObject! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:45'!
quitarNectar
^(self nectar > 3)
	ifTrue: [ 3 ]
	ifFalse: [ self nectar].! !

Object subclass: #Piquera
	instanceVariableNames: 'centimetros colmena abejas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:36'!
abejas
	^ abejas! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:36'!
abejas: anObject
	abejas := anObject! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:24'!
centimetros
	^ centimetros! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:24'!
centimetros: anObject
	centimetros := anObject! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:29'!
colmena
	^ colmena! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:29'!
colmena: anObject
	colmena := anObject! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 5/23/2013 01:17'!
intentaPasar: unaAbeja
|guardiana|
guardiana := Guardiana new.
guardiana initialize.
guardiana colmena: self colmena.
self abejas add: guardiana.
"((self abejas select:[:unaA | unaA == guardiana]) asOrderedCollection first) picarSiHayIntrusa: {unaAbeja}."
self colmena abejas add: guardiana. "self colmena agregarAbeja: guardiana."
guardiana picarSiHayIntrusa: {unaAbeja}
! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 5/22/2013 13:19'!
sacarAbeja: unaAbeja 
self abejas remove: unaAbeja.! !
